<?php defined('_JEXEC') or die('Restricted access');

class pm_payanyway extends PaymentRoot{
	
    function showPaymentForm($params, $pmconfigs){
	    self::loadLanguageFile();
        include(dirname(__FILE__) . "/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
		self::loadLanguageFile();

		$array_params = array('online_payment', 'payment_server', 'mnt_id', 'mnt_dataintegrity_code', 'mnt_test_mode', 'mnt_currency_code', 'unitId', 'accountId', 'payanyway_login', 'payanyway_pasword');
		foreach ($array_params as $key){
			if (!isset($params[$key])) $params[$key] = '';
		}
		$orders = JModel::getInstance('orders', 'JshoppingModel'); //admin model
		$currencies = JModel::getInstance('currencies', 'JshoppingModel'); //admin model
		include(dirname(__FILE__) . "/adminparamsform.php");
	}

    /**
     * Подключение необходимого языкового файла для модуля
     */
    function loadLanguageFile(){
        $lang = JFactory::getLanguage();
        // переменная с полным именем языкового файла (с путём)
        $lang_file = JPATH_ROOT . '/components/com_jshopping/lang/' . $lang->getTag() . '.pm_payanyway.php';
        // пытаемся подключить языковой файл, если такого нет - подключается по-умолчанию (en-GB.php)
        if(file_exists($lang_file))
            require_once $lang_file;
        else
            require_once JPATH_ROOT . '/components/com_jshopping/lang/' . 'en-GB.pm_payanyway.php';
    }

	const paw_kassa_VAT0     = '1104';  // НДС 0%
	const paw_kassa_VAT10    = '1103';  // НДС 10%
	const paw_kassa_VAT18    = '1102';  // НДС 18%
	const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
	const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
	const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%

	private static function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
												 $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
	{
		if ($success === true)
			$resultCode = '200';
		elseif ($repeatRequest === true)
			$resultCode = '402';
		else
			$resultCode = '500';
		$mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
		$response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$response .= "<MNT_RESPONSE>\n";
		$response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
		$response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
		$response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
		$response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
		if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
		{
			$response .= "<MNT_ATTRIBUTES>\n";
			foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
				if (!empty($v))
					$response .= "<ATTRIBUTE>\n<KEY>{$k}</KEY>\n<VALUE>{$v}</VALUE>\n</ATTRIBUTE>\n";
			$response .= "</MNT_ATTRIBUTES>\n";
		}
		$response .= "</MNT_RESPONSE>\n";
		if ($echo === true)
		{
			header("Content-type: application/xml");
			echo $response;
		}
		else
			return $response;
		if ($die === true)
			die;
		return '';
	}

    private function cleanProductName($str)
    {
        return preg_replace('/[^0-9a-zA-Zа-яА-ЯёЁ\-\,\.\(\)\;\_\№\/\+\& ]/ui', '', htmlspecialchars_decode($str, ENT_QUOTES));
    }

	function checkTransaction($pmconfigs, $order, $act){
		if (isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID'])
			&& isset($_REQUEST['MNT_AMOUNT']) && isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE'])
			&& isset($_REQUEST['MNT_SIGNATURE'])) 
		{
			$dataIntegrityCode  = $pmconfigs['mnt_dataintegrity_code'];
			$mntKassa = $pmconfigs['mnt_kassa'];
			$signature	 = md5("{$_REQUEST['MNT_ID']}{$_REQUEST['MNT_TRANSACTION_ID']}{$_REQUEST['MNT_OPERATION_ID']}{$_REQUEST['MNT_AMOUNT']}{$_REQUEST['MNT_CURRENCY_CODE']}{$_REQUEST['MNT_TEST_MODE']}{$dataIntegrityCode}");
			$amount = number_format(getPriceFromCurrency($order->order_total, $pmconfigs['mnt_currency_code']), 2, '.', '');
			if ($_REQUEST['MNT_SIGNATURE'] == $signature && $amount == $_REQUEST['MNT_AMOUNT'])
			{
				if ($mntKassa == '1')
				{
					$clientEmail = $order->email;
					$items = $order->getAllItems();
					$inventoryPositions = array();
					foreach ($items as $item)
					{
						$vatTag = self::paw_kassa_VATNOVAT;
						$productTax = floatval($item->product_tax);
						if ($productTax == 10)
							$vatTag = self::paw_kassa_VAT10;
						if ($productTax == 18)
							$vatTag = self::paw_kassa_VAT18;
						$inventoryPositions[] = array(
							'name' => $this->cleanProductName($item->product_name),
							'quantity' => $item->product_quantity,
							'price' => $item->product_item_price,
							'vatTag' => $vatTag
						);
					}
					$kassa_delivery = null;
					if ($order->order_shipping > 0)
						$kassa_delivery = $order->order_shipping;
					$kassa_inventory = json_encode($inventoryPositions, JSON_PRETTY_PRINT);
					self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'], $dataIntegrityCode,
						true, false, true, true, $kassa_inventory, $clientEmail, $kassa_delivery);             	// 200
				}
				echo 'SUCCESS';
				return array(1, $_REQUEST['MNT_TRANSACTION_ID']);
			} else {
				echo 'FAIL';
				return array(0, $_REQUEST['MNT_TRANSACTION_ID']);
			}
		} else {
			echo 'FAIL';
			return array(0, $_REQUEST['MNT_TRANSACTION_ID']);
		}		
	}
	
	function invoice($pmconfigs, $order, $act) {
		
	    self::loadLanguageFile();

		require_once (JPATH_LIBRARIES.'/MonetaAPI/MonetaWebService.php');

		switch ($pmconfigs['payment_server']) {
			case "demo.moneta.ru":
				$service = new MonetaWebService("https://demo.moneta.ru/services.wsdl", $pmconfigs['payanyway_login'], $pmconfigs['payanyway_password']);
				break;
			case "www.payanyway.ru":
				$service = new MonetaWebService("https://service.payanyway.ru/services.wsdl", $pmconfigs['payanyway_login'], $pmconfigs['payanyway_password']);
				break;
		}

		try {
			$totalAmount = $_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'];
			$fee = "-";
			
			// запрос стоимости и комиссии
			if (isset($_REQUEST['paymentSystem_accountId'])) {
				$transactionRequestType = new MonetaForecastTransactionRequest();
				$transactionRequestType->payer = $_REQUEST['paymentSystem_accountId'];
				$transactionRequestType->payee = $_REQUEST['MNT_ID'];
				$transactionRequestType->amount = $_REQUEST['MNT_AMOUNT'];
				$transactionRequestType->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];
				$forecast = $service->ForecastTransaction($transactionRequestType);
				$totalAmount = number_format($forecast->payerAmount,2,'.','')." ".$forecast->payerCurrency;
				$fee = number_format($forecast->payerFee,2,'.','')." ".$forecast->payerCurrency;
			}
			
			// получить данные счета
			$request = new MonetaInvoiceRequest();
			if (isset($_REQUEST['paymentSystem_accountId']))
				$request->payer = $_REQUEST['paymentSystem_accountId']; 
			$request->payee = $_REQUEST['MNT_ID']; 
			$request->amount = $_REQUEST['MNT_AMOUNT'];
			$request->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];
			$request->description = $_REQUEST['MNT_DESCRIPTION'];
			
			$operationInfo = new MonetaOperationInfo();
			$a = new MonetaKeyValueAttribute();
			$a->key = 'CUSTOMURLPARAMETERS';
			$a->value = "js_paymentclass=".$_REQUEST['js_paymentclass'];
			$operationInfo->addAttribute($a);
	
			if ($_REQUEST['js_paymentclass'] == 'pm_payanyway_post') {
				$a0 = new MonetaKeyValueAttribute();
				$a0->key = 'mailofrussiaindex';
				$a0->value = $_REQUEST['additionalParameters_mailofrussiaSenderIndex'];
				$operationInfo->addAttribute($a0);
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'mailofrussiaregion';
				$a1->value = $_REQUEST['additionalParameters_mailofrussiaSenderRegion'];
				$operationInfo->addAttribute($a1);
				$a2 = new MonetaKeyValueAttribute();
				$a2->key = 'mailofrussiaaddress';
				$a2->value = $_REQUEST['additionalParameters_mailofrussiaSenderAddress'];
				$operationInfo->addAttribute($a2);
				$a3 = new MonetaKeyValueAttribute();
				$a3->key = 'mailofrussianame';
				$a3->value = $_REQUEST['additionalParameters_mailofrussiaSenderName'];
				$operationInfo->addAttribute($a3);
			} elseif ($_REQUEST['js_paymentclass'] == 'pm_payanyway_euroset') {
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'rapidamphone';
				$a1->value = $_REQUEST['additionalParameters_rapidaPhone'];
				$operationInfo->addAttribute($a1);
			}
			$request->operationInfo = $operationInfo;
			
			$response = $service->Invoice($request);
			if ($_REQUEST['js_paymentclass'] == 'pm_payanyway_euroset') {
				$response1 = $service->GetOperationDetailsById($response->transaction);
				foreach ($response1->operation->attribute as $attr) {
					if ($attr->key == 'rapidatid') {
						$transaction = $attr->value;
					}
				}
			} else {
				$transaction = $response->transaction;
			}
			
			$amount = $_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'];

			$invoice['status'] = $response->status;
			$invoice['unit_id'] = $_REQUEST['paymentSystem_unitId'];
			$invoice['payment_server'] = $pmconfigs['payment_server'];
			$invoice['transaction'] = str_pad($transaction, 10, "0", STR_PAD_LEFT);
			$invoice['operation'] = $response->transaction;
			$invoice['amount'] = $_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'];
			$invoice['payer_amount'] = $totalAmount;
			$invoice['payer_fee'] = $fee;

			$order->order_custom_info = serialize($invoice);
			$order->store();

			$cart = JModel::getInstance('cart', 'jshop');
			$cart->load();                
			$cart->getSum();
			$cart->clear();

			return array(2, $_REQUEST['MNT_TRANSACTION_ID']);
		} catch (Exception $e) {
			$invoice['status'] = 'FAILED';
			$invoice['error_message'] = $e->getMessage();

			$order->order_custom_info = serialize($invoice);
			$order->store();
			return array(2, $e->getMessage());
		}
	}
	
	function showEndForm($pmconfigs, $order){
        
        $pm_method = JTable::getInstance('paymentMethod', 'jshop');
        $payment_method_id = $order->payment_method_id;
        $pm_method->load($payment_method_id);

        $uri = JURI::getInstance();        
        $liveurlhost = $uri->toString(array("scheme",'host', 'port'));
		$currencies = JSFactory::getAllCurrency();
		
		$formParams = array();
		$formParams["MNT_ID"] = $pmconfigs['mnt_id'];
		$formParams["MNT_TRANSACTION_ID"] = $order->order_id;
		$formParams["MNT_TEST_MODE"] = $pmconfigs['mnt_test_mode'];
		$formParams["MNT_AMOUNT"] = number_format(getPriceFromCurrency($order->order_total, $pmconfigs['mnt_currency_code']), 2, '.', '');
		$formParams["MNT_CURRENCY_CODE"] = ($currencies[$pmconfigs['mnt_currency_code']]->currency_code_iso == 'RUR') ? 'RUB' : 'RUB';
		$formParams["MNT_SIGNATURE"]  = md5($pmconfigs['mnt_id'].$order->order_id.$formParams["MNT_AMOUNT"].$formParams["MNT_CURRENCY_CODE"].$pmconfigs['mnt_test_mode'].$pmconfigs['mnt_dataintegrity_code']);
		$formParams["MNT_DESCRIPTION"] = "Заказ номер $order->order_number";
		$formParams["js_paymentclass"] = $pm_method->payment_class;

		if (!empty($pmconfigs['unitId'])){
			$formParams["paymentSystem.unitId"] = $pmconfigs['unitId'];
			if ($pm_method->payment_class !== 'pm_payanyway') {
				$formParams["paymentSystem.limitIds"] = $pmconfigs['unitId'];
			}
		}
		if (!empty($pmconfigs['accountId']))
			$formParams["paymentSystem.accountId"] = $pmconfigs['accountId'];
		if ($pm_method->payment_class !== 'pm_payanyway') {
			$formParams["followup"] = "true";
			$formParams["javascriptEnabled"] = "true";
		}
		
		$payment_params = unserialize($order->payment_params_data);
		switch ($pm_method->payment_class)
		{
			case "pm_payanyway_euroset":
				$formParams["additionalParameters.rapidaPhone"] = $payment_params['rapidaPhone'];
				break;
			case "pm_payanyway_alfaclick":
				$formParams["additionalParameters.alfaIdClient"] = $payment_params['alfaIdClient'];
				$formParams["additionalParameters.alfaPaymentPurpose"] = $payment_params['alfaPaymentPurpose'];
				break;
			case "pm_payanyway_dengimail":
				$formParams["additionalParameters.dmrBuyerEmail"] = $payment_params['dmrBuyerEmail'];
				break;
			case "pm_payanyway_moneymail":
				$formParams["additionalParameters.buyerEmail"] = $payment_params['buyerEmail'];
				break;
			case "pm_payanyway_post":
				$formParams["additionalParameters.mailofrussiaSenderIndex"] = $payment_params['mailofrussiaSenderIndex'];
				$formParams["additionalParameters.mailofrussiaSenderRegion"] = $payment_params['mailofrussiaSenderRegion'];
				$formParams["additionalParameters.mailofrussiaSenderAddress"] = $payment_params['mailofrussiaSenderAddress'];
				$formParams["additionalParameters.mailofrussiaSenderName"] = $payment_params['mailofrussiaSenderName'];
				break;
			case "pm_payanyway_webmoney":
				$formParams["paymentSystem.accountId"] = $payment_params['accountId'];
				break;
			case "pm_payanyway_qiwi":
				$formParams["additionalParameters.qiwiUser"] = $payment_params['qiwiUser'];
				$formParams["additionalParameters.qiwiComment"] = $payment_params['qiwiComment'];
				break;
			default:
				break;
		}
		
		if (!$pmconfigs['invoice'])
		{
			$host = "https://".$pmconfigs['payment_server']."/assistant.htm";
			$formParams["MNT_SUCCESS_URL"] = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=".$pm_method->payment_class);
			$formParams["MNT_FAIL_URL"] = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=".$pm_method->payment_class);
		}
		else
			$host = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=invoice");
?>

        <html>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <body>
        <form id="paymentform" action="<?php print $host?>" name = "paymentform" method = "post">
			<?php foreach ($formParams as $key=>$value): ?>
				<input type='hidden' name='<?php print $key; ?>' value='<?php print $value; ?>'/>
			<?php endforeach; ?>
        </form>        
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
	
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("MNT_TRANSACTION_ID");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
		
		return $params;
    }
    
}
?>